<?php
/**
 # com_jvframework - JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class JVLayoutParser{
    protected $options;
    protected $layouts;
    
    
	function JVLayoutParser(){
		$args = func_get_args();
		call_user_func_array(array(&$this, '__construct'), $args);
	}
    
    public function __construct(&$layouts, $options) {
        $this->layouts = $layouts;
        $this->options = $options;
    }
    
    public function parse(){
        $hook    = JVHooks::getInstance();
        $layouts = $this->layouts;        
        $html    = $hook->docType();
       
        if(is_array($layouts->get('main'))){
            foreach($layouts->get('main') as $mainItem){
                if(is_array($mainItem) && isset($mainItem['name'])){
                    $group = $layouts->getGroup($mainItem['name']); // Get group data
                    
                    if ($layouts->isSideBar($mainItem['name']) && $layouts->hasGroupItems($mainItem['name'])) {
                        $class = '';
                        if(isset($mainItem['class'])){
                            $class = ' class="'.$mainItem['class'].'"';
                        }                            
                        $html .= "<div id='jv-{$mainItem['name']}'".(isset($mainItem['class']) ? ' class="'.$mainItem['class'].'"': '').'>';
                        $html .= "<div class='jv-sbinner'>";
                    }

                    foreach($group as $block){
                        if( isset($mainItem['type'])){
                            $block['option']['type'] = $mainItem['type'];
                        }
                        
                        $html .= $this->autoPosition($block);
                    } 
                    
                    if ($layouts->isSideBar($mainItem['name']) && $layouts->hasGroupItems($mainItem['name'])) {
                        $html .= "</div>";
                        $html .= "</div>";
                    }                   
                }else{
                    $html     = $this->addCustomElement($mainItem, $html);
                    $mainItem = $this->customElement($mainItem);
                    $html .= (string ) $mainItem;
                }                
            }
        }
       
        return $html."</html>";
    }
        
    /**
     * Custom Element To Add Specific Class To Element In Main Layout
     * 
     * @param  string $element      
     * @return void
     */
    protected function customElement($element){
        $layouts = JVFactory::getJVLayout();
        $class   = '';
        //Specific class for layout color
        if(preg_match('/<body>/', $element)){
            $param = JVFactory::getParameter();
            $fontpage = JFactory::getApplication()->getMenu()->getActive() == JFactory::getApplication()->getMenu()->getDefault();
            $class .= $fontpage ? 'home' : 'page';
            $class .= JVFactory::isRTL() ? ' rtl' : '';
            $class .= $param->getTemplateColor() == '-1' ? ' color-default' : ' color-'.$param->getTemplateColor();                        
            $element = str_replace(">", " class='{$class}'>", $element); $class = '';
         }
        
        //Specific class for layout type
        if (preg_match('/id=[\'|"]jv-container[\'|"]/',$element)) {
            $layout_type_name = $this->options->getParam('layout_type_name', 'left-main-right');
            
            if ($layouts->hasGroupItems($layouts->getSideBar2()) && $layouts->hasGroupItems($layouts->getSideBar1())) {
                $class = 'hasSidebars';                
            } else {
                if ($layouts->hasGroupItems($layouts->getSideBar2())) {
                    $class = 'hasSidebar2';
                    $layout_type_name = $this->getNewLayoutType($layout_type_name, 2);
                    
                }elseif ($layouts->hasGroupItems($layouts->getSideBar1())) {
                    $class = 'hasSidebar1';
                    $layout_type_name = $this->getNewLayoutType($layout_type_name, 1);
                }
            }
                        
            $element = str_replace(">", " class='{$layout_type_name} $class'>", $element); $class = '';
        }
        
        return $element;
    }
    
    /**
     * Add Custom Element
     * 
     * @param  string $element
     * @param  string $html
     * 
     * @return void
     */
    protected function addCustomElement($element, $html){
         $browser = new Browser();                    
         $useragent = JVFactory::getUserAgent();
         
         //Add mobile toolbar         
         if(preg_match('/<body>/', $element) && $browser->isMobile()){            
            $menus  =& JSite::getMenu();
            $menu   = $menus->getActive();
            $Itemid = isset($menu->id) ? $menu->id : 0;
            $url    = 'index.php?';
            $activeTheme = 'jvtheme'.JVFactory::getFramework()->getActiveTheme()->id;
            
			if($useragent != 'standard'){	 
			     $html .="
                 <div class='switch_version'>
                    <a title=\" Desktop version \" class=\"desktop\" href='javascript:void(0);' onclick=\"JVUserTools.changeVersion('".$activeTheme."','standard');\"></a>
                    <a title=\" Login \"  class=\"login\"  href='index.php?option=com_users&view=login'></a>
                    <a title=\" Search \" class=\"search\" href='javascript:void(0);' onclick=\"JVUserTools.showSearch('".$Itemid."');\"></a>
                 </div>
                 <form id='mobileSearch' style='display:none;' class='search_result' method='post' action='".JURI::base()."index.php?option=com_search'>    
                    <label for='search_searchword'>".JText::_('Search Keyword')."</label>
                    <input type='text' class='inputbox' value='' maxlength='20' id='search_searchword' name='searchword'/>
                    <input type='hidden' value='".$Itemid."' name='Itemid'/>
                    <input type='hidden' value='search' name='task'/>
                    <button class='button' onclick='this.form.submit()' name='Search'>".JText::_('Search')."</button>
                </form>
                
                 ";
                 $html .= $this->getMobileMenu();
                  
			} elseif($this->options->enableMobileLayout() == 1) {			 
				$html .= "
                <div class='switch_version'>
                    <a title=\" PDA version \" class=\"pda\" href='javascript:void(0);' onclick=\"JVUserTools.changeVersion('".$activeTheme."','". strtolower($browser->getBrowser()) ."');\"></a>
                </div>";
			}						
        } 
        
        //Add usertool
        if(preg_match('/<\/body>/', $element)  && $this->options->enableUsertool() && !$browser->isMobile()){
            $html .= JVUsertool::getUsertool();
        }
        
        return $html;
    }
    
    private function getNewLayoutType($layout_type, $sidebar){
        switch($layout_type){
            case 'default':
            case 'left-main-right': 
                return $sidebar == 1 ? 'left-main': 'main-right';   
            break;
            
            case 'left-right-main':
                return $sidebar == 2 ? 'left-main':'right-main';   
            break;
            
            case 'right-main-left':  
                return $sidebar == 1 ? 'main-left': 'right-main';   
            break;
                      
            case 'right-left-main':
                return $sidebar == 1 ? 'left-main': 'right-main'; 
            break;
            
            case 'main-right-left':    
                return $sidebar == 2 ? 'main-left':'main-right';
            break;             
            
            case 'main-left-right':
                return $sidebar == 1 ? 'main-left':'main-right';
            break;
            
            default:
                return $layout_type;
            break;
        }
    }    
    
    /**
     * Load modules  
     * 
     * @param array $block Block data. 
     * @access public 
     * @return string html and joomla jdoc. 
     */
    public function autoPosition($block) {
        $doc = JFactory::getDocument();
        $browser = new Browser();
        
        if(isset($block['option']['name']) == false) return false;        
        
        $enablePosition = $this->layouts->enablePos($block['option']['name']);
        $pclass = '';
        
        if(isset($block['items']) === false || count($block['items']) == 0){
            return false;
        }
        
        $numEPosition = (('footer' == $block['option']['name'] && (bool) $this->options->enableCopyright()) || $this->layouts->inBlock($block['option']['name'], 'component') || $this->layouts->inBlock($block['option']['name'], 'head') || $this->layouts->inBlock('footer', $this->options->getLogoPosition()) || $this->layouts->inBlock($block['option']['name'], $this->options->getLogoPosition())) ? count($enablePosition) + 1 : count($enablePosition);
        if($numEPosition == 0) return;      
        
        if(isset($block['option']['equal']) && $numEPosition > 1){
            if($block['option']['equal'] == 'width' || $block['option']['equal'] == 'both'){
                $pclass =  'jv-grid u-1-'.$numEPosition;
                if($browser->isBrowser('Opera') && isset($block['option']['type']) && $block['option']['type']=='wrap'){
                    $pclass = 'jv-grid px-'.$numEPosition;                
                    $width  = $this->options->getTemplateWidth()/$numEPosition;
                    $doc->addStyleDeclaration('.px-'.$numEPosition.'{width: '.round($width, 5).'px;}');
                } 
            }
            
            if($block['option']['equal'] == 'height' || $block['option']['equal'] == 'both'){
                if($pclass == ''){
                    $pclass = 'e-height';
                }else{
                    $pclass.= ' e-height';
                }
                
                if(isset($block['option']['id'])){
                    $doc->addScriptDeclaration("
                        window.addEvent('domready', function() {
                            JVEqualHeight('#".$block['option']['id']." .e-height .jv-module');
                        });"
                    );
                }
            }
        }else{
            $pclass =  'u-1';    
        } 
                
        $html = $this->beginBlock($block['option']);        
        
        foreach($block['items'] as $key => $item){
            if(is_array($item)){
                if($pclass != ''){
                    $item['class'] = isset($item['class']) ? $item['class'].' '.$pclass : $pclass;
                }  
                
                $html .= $this->loadModule($item);
                
            }else{
                $html .= $item;
            }
        }
        
        $html  .= $this->endBlock($block['option']);
        
        return $html;        
    }

    /**
     * Load module position
     * 
     * @param  array $itemData position data
     * @access public 
     * @return string html and jdoc:include.    
     */
    public function loadModule($item) {
        if(isset($item['name']) == false) return;
        
        if($item['name'] == 'head'){
            return '<jdoc:include type="head" />';
        }
        if($item['name'] == 'message'){ 
            return $this->getMessage();
        }
                
        $html         = '';
        $attribs      = array();
        $item['name'] = isset($item['name']) ? $item['name'] : null;
        
        if($item['name'] == 'component'){           
            $item['type'] = $item['name'];
            $item['name'] = null;
            
        }else{
            $item['type']     = $attribs['type'] = isset($item['type']) ? $item['type'] : 'modules';
            $attribs['style'] = isset($item['style']) ? $item['style'] : 'JVxhtml';
        }
        
        if($item['name'] != null){
            $html .= $this->beginPosition($item);
        }
        
        $document = JVFactory::getFramework()->getDocument();
        $html    .= $document->getBuffer($item['type'], $item['name'], $attribs);
        
        if($this->options->getLogoPosition() == $item['name']){
            $html .= $this->options->getLogo();
        }
        
        if ('footer' == $item['name']) {
            if ($this->options->enableCopyright() == '1') {
                $html .= "<div class='copyright'>";
                $html .= $this->options->getCopyright();
                $html .= $this->options->getJoomlaCopyright();
                $html .= "</div>";
            }
            $html .= $this->options->getFooterScript();
        }
        
        if($item['name'] != null){
            $html .= $this->endPosition($item);
        }
        
        return $html;
    }
    
    
    public function beginPosition($item){
        $html = ''; 
        if((isset($item['name']) && $this->layouts->JFModules($item['name'])) || $this->options->getLogoPosition() == $item['name']){
            $class  = isset($item['class']) ? 'jv-'.$item['name'].' '.$item['class'] : 'jv-'.$item['name'];
            
        
            $class .= ($this->options->getTemplateColor() != -1) ? ' '.$this->options->getTemplateColor() : '';
            $html  .= "<div class='$class'>";
            $html  .= isset($item['inner']) ? "<div class='{$item['inner']}'>" : '';
        } 
        
        return $html;
    }
    
    public function endPosition($item){
        $html = '';
        
        if((isset($item['name']) && $this->layouts->JFModules($item['name'])) || $this->options->getLogoPosition() == $item['name']){
            $html  .= isset($item['inner']) ? "</div>" : '';            
            $html .= "</div>";
        }
        
        return $html;
    }
    
    /**
     * Begin block
     * 
     * @param array $blockOption
     * @return string html
     */
    public function beginBlock($blockOption) {
        $html = '';      
        
        if (isset($blockOption['id']) || isset($blockOption['class'])) {
            $atribute = '';
            if (isset($blockOption['id'])) {
                $atribute .= "id='{$blockOption['id']}'";
            }
            if (isset($blockOption['class'])) {
                $atribute .= " class='{$blockOption['class']}'";
            }

            $html .= "<div $atribute>";
        }
                  
        if (isset($blockOption['type']) && $blockOption['type'] == 'wrap') {
            $html .= "<div class='jv-block'>";
        }

        if (isset($blockOption['inner'])) {
            $html .= "<div class='{$blockOption['inner']}'>";
        }

        return $html;

    }
    
    /**
     * End block
     * 
     * @param array $blockOption
     * @return string html
     */
    function endBlock($blockOption) {        
        $html = '';
        if (isset($blockOption['id']) || isset($blockOption['class'])) {
            $html .= "</div>";
        }

        if (isset($blockOption['type']) && $blockOption['type'] == 'wrap') {
            $html .= "</div>";
        }

        if (isset($blockOption['inner'])) {
            $html .= "</div>";
        }
        return $html;
    }    
    
    /**
     * Get Message
     *
     * @return string html
     */
    public function getMessage(){
        $mainframe = JFactory::getApplication();
        $messages  = $mainframe->getMessageQueue();
        $html      = '';
				
        if($messages != array()){            
            foreach($messages as $mess){
                if($mess['message'] != ''){
                    $html .= '<p class="notice '.$mess['type'].'">';
                    $html .= '<span class="icon"></span><strong>'.ucfirst($mess['type']).':</strong> '.$mess['message'].'';
                    $html .='</p>';
                }
                 
            }
        }
        return $html;
    }
    
    /**
     * Get Menu Option
     *
     * @return array menuoption
     */ 
    public function getMobileMenu(){        
        $options = @$this->getMenuOption();
        $html = JHTML::_('input.genericlist',  $options, 'handheldMenu', 'onchange="gotourl(this.options[this.selectedIndex].className)" class="menu-iphone"', 'value', 'text', JRequest::getInt('Itemid'), 'handheldMenu');
        
        return $html;       
    }
    
    /**
     * Get Menu Option
     *
     * @return array menuoption
     */ 
    public function getMenuOption(){
		$db =& JFactory::getDBO();
        $node = JFactory::getXMLParser('Simple');
        $useragen = JVFactory::getUserAgent();
        
		$menuType =  $this->options->getParam($useragen.'_mobileMenu') != '' ? $this->options->getParam($useragen.'_mobileMenu') : $this->options->getParam('mobileMenu','mainmenu');

		if (!empty($menuType)) {
			$where = ' WHERE menutype = '.$db->Quote($menuType);
		} else {
			$where = ' WHERE 1';
		}

		// load the list of menu types
		// TODO: move query to model
		$query = 'SELECT menutype, title' .
				' FROM #__menu_types' .
				' ORDER BY title';
		$db->setQuery($query);
		$menuTypes = $db->loadObjectList();

		// load the list of menu items
		// TODO: move query to model
		$query = 'SELECT id, link, parent_id, title, menutype, type' .
				' FROM #__menu' .
				$where .
				' ORDER BY menutype, parent_id, ordering'
				;

		$db->setQuery($query);
		$menuItems = $db->loadObjectList();
        
        // load the list of menu items
		// TODO: move query to model
		$query = 'SELECT id, parent_id, title, menutype, type' .
				' FROM #__menu' .				
				' WHERE id=1'
				;

		$db->setQuery($query);
		$rootItems = $db->loadObject();

		// establish the hierarchy of the menu
		// TODO: use node model
		$children = array();
        $children[] = array( $rootItems );
        
		if ($menuItems)
		{
			// first pass - collect children
			foreach ($menuItems as $v)
			{
				$pt	= $v->parent_id;
				$list	= @$children[$pt] ? $children[$pt] : array();
				array_push($list, $v);
				$children[$pt] = $list;
			}
		}

		// second pass - get an indent list of the items
		$list = JHtml::_('menu.treerecurse', 0, '', array(), $children, 9999, 0, 0);
        
		// assemble into menutype groups
		$n = count( $list );
		$groupedList = array();
		foreach ($list as $k => $v) {
			$groupedList[$v->menutype][] = &$list[$k];
		}

		// assemble menu items to the array
		$options 	= array();
        
		foreach ($menuTypes as $type)
		{
			if ($menuType == '')
			{
				$options[]	= JHTML::_('select.option',  '0', '&nbsp;', 'value', 'text', true);
				$options[]	= JHTML::_('select.option',  $type->menutype, $type->title . ' - ' . JText::_( 'Top' ), 'value', 'text', true );
			}
			if (isset( $groupedList[$type->menutype] ))
			{
				$n = count( $groupedList[$type->menutype] );
				for ($i = 0; $i < $n; $i++)
				{
					$item = &$groupedList[$type->menutype][$i];
					
					//If menutype is changed but item is not saved yet, use the new type in the list
					if ( JRequest::getString('option', '', 'get') == 'com_menus' ) {
						$currentItemArray = JRequest::getVar('cid', array(0), '', 'array');
						$currentItemId = (int) $currentItemArray[0];
						$currentItemType = JRequest::getString('type', $item->type, 'get');
						if ( $currentItemId == $item->id && $currentItemType != $item->type) {
							$item->type = $currentItemType;
						}
					} 
                    
                    if ((strpos($item->link, 'index.php?') === 0) && (strpos($item->link, 'Itemid=') === false)) {
    					$item->url = $item->link.'&amp;Itemid='.$item->id;
    				} else {
    					$item->url = $item->link;
    				}     
                                 
					$options[] = JHTML::_('input.option',  $item->id, '' .$item->treename, " class='".JRoute::_($item->url)."'" );
                }
			}
		}
        
		return $options;
	}
}